unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DB, Grids, DBGrids, StdCtrls, ExtCtrls, QRCtrls, QuickRpt ;

type
  TForm2 = class(TForm)
    QuickRep1: TQuickRep;
    qrbTITLE: TQRBand;
    qrbcolhead: TQRBand;
    qrbdetail: TQRBand;
    qrbpagefoot: TQRBand;
    dsReport: TDataSource;
    qrlTitle1: TQRLabel;
    qrlTitle2: TQRLabel;
    qrSTitleLine: TQRShape;
    QRDBText1: TQRDBText;
    QRDBText2: TQRDBText;
    QRDBText3: TQRDBText;
    QRDBText4: TQRDBText;
    QRDBText5: TQRDBText;
    QRDBText6: TQRDBText;
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure qrbdetailBeforePrint(Sender: TQRCustomBand;
      var PrintBand: Boolean);
  private
    { Private declarations }
    NowRightEnd : Integer;
    ColTitleList: TList;
    ColDetailList:TList;
    myDBGrid: TDBGrid;
    myDataSet: TDataSet;


    myTitle1,myTitle2 : String;
    TempColumnStr : String; // For Delete Same Column
    procedure InsertCol(Title,FieldName:String;pWidth:Integer; top_position:integer);
    procedure PreparePrint;
  public
    { Public declarations }
    procedure SetDataSet(pDataSet:TDataSet);
    procedure SetTitles(pTitle1,pTitle2:String);
    procedure SetDBGrid(pDBGrid:TDBGrid);
    procedure SetPortrait;
    procedure SetLandScape;
    procedure Preview;
    procedure Print;
//    procedure ToFile;
  end;

var Form2: TForm2;

implementation

{$R *.dfm}

// COPY FROM XPROCS //
function strPadChL(const S: String; C: Char; Len: Integer): String;
begin
    Result:=S;
    while Length(Result)<Len do Result:=C+Result;
end;

function strPadChR(const S: String; C: Char; Len: Integer): String;
begin
    Result:=S;
    while Length(Result)<Len do Result:=Result+C;
end;

function strMake(C: Char; Len: Integer): String;
begin
    Result:=strPadChL('',C,Len);
end;

function strPadR(const S: String; Len: Integer): String;
begin
    Result:=strPadChR(S,' ',Len);
end;


procedure Tform2.SetTitles(pTitle1,pTitle2:String);
begin
    myTitle1 := pTitle1;
    myTitle2 := pTitle2;
end;

procedure Tform2.SetDataSet(pDataSet:TDataSet);
begin
end;

procedure Tform2.SetDBGrid(pDBGrid:TDBGrid);
begin
    myDBGrid := TDBGrid.Create(nil);
    myDBGrid := pDBGrid;
    myDataSet := myDBGrid.DataSource.DataSet;
    dsReport.DataSet := myDataSet;
end;

procedure Tform2.InsertCol(Title,FieldName:String;pWidth : Integer; top_position:integer);
var
    AqrLabel  :  TQRLabel;
    AqrDBText :  TQRDBText;
    ColWidth : Integer;
begin
    AqrLabel := TQRLabel.Create(form2);
    AqrDBText:= TQRDBText.Create(form2);
    ColWidth := Trunc(pWidth*1.35) ;

    with AqrLabel do begin
        Parent := qrbColHead;

        Left := NowRightEnd;
        Top := (qrbColHead.Height-12) div 2;
        Width := ColWidth;
        Height := 16;
        Caption := Trim(Title);
        Font.Name := 'ө';
        Font.Size := 12;
        //Transparent := True;
        Visible := true;
        Enabled := true;
        //Alignment := taCenter;
    end;

    with AqrDBText do begin
        Parent := qrbDetail;
        Left := NowRightEnd;
        //Top := (qrbDetail.Height-12) div 2;
        Top := top_position*16;
        Width := ColWidth;
        Height := 16;
        Font.Name := 'ө';
        Font.Size := 12;
        //Transparent := True;
        DataSet := dsReport.DataSet;
        DataField := FieldName;
        AutoStretch := True;
        //Alignment := taCenter;
    end;
    NowRightEnd := NowRightEnd + ColWidth;
end;

procedure Tform2.PreparePrint;
    var i,j,ColWidth :Integer;
begin
    mydataset.Open;
    mydataset.First;
    j:=0;
    while not mydataset.Eof do begin
        with myDBGrid do begin
            NowRightEnd :=0;
            for i := 0 to FieldCount-1 do begin
                if Columns.Items[i].Width > 15 then begin
                    InsertCol(Columns.Items[i].Title.Caption,Columns.Items[i].FieldName,50,j);
                    //InsertCol(Columns.Items[i].Title.Caption,Columns.Items[i].FieldName,Columns.Items[i].Width);
                end;
            end;
        end;
        inc(j);
        mydataset.Next;
    end;

    TempColumnStr := 'NO_MEAN'; // only give a init value
    qrlTitle1.Caption := myTitle1;
    qrSTitleLine.Width := qrlTitle1.Width;
    qrlTitle2.Caption := myTitle2;
end;

procedure Tform2.Preview;
begin
    preParePrint;
    QuickRep1.Preview;
end;

procedure Tform2.Print;
begin
    preParePrint;
    QuickRep1.Print;
end;

procedure Tform2.SetPortrait;
begin
    //QuickRep1.Orientation := poPortrait;
end;

procedure Tform2.SetLandScape;
begin
    //QuickReport1.Orientation := poLandscape;
end;
(*
procedure Tform2.ToFile;
var
  F: TextFile;
  S: string;
  i : Integer;
  lastString : String;
begin
    lastString := 'YDC';
    if SaveDialog1.Execute then          { Display Open dialog box }
    begin
        AssignFile(F, SaveDialog1.FileName);   { File selected in dialog box }
        ReWrite(F);

        // Write Titles
        writeln(F, myTitle1);                          { Read the first line out of the file }
        writeln(F,strMake('=',length(myTitle1)));
        writeln(F);

        writeln(F, myTitle2);                          { Read the first line out of the file }
        writeln(F);

        S := '';
        with myDBGrid do
        for i := 0 to FieldCount-1 do
            if Columns.Items[i].Width > 15 then
               S := S + strPadr(Columns.Items[i].Title.Caption,2+(Columns.Items[i].Width + 8) div 9 );
        writeln(F,S);
        writeln(F,strMake('-',length(S)));

        // Write Data
        with myDataSet do
        begin
             First;
             while not EOF do
             begin
                 S := '';
                 with myDBGrid do
                 for i := 0 to FieldCount-1 do
                     if Columns.Items[i].Width > 15 then
                        S := S + strPadr(FieldByName(Columns.Items[i].FieldName).AsString,2+(Columns.Items[i].Width + 8) div 9 );
                 if S <> lastString then // Delete Same Columns
                    writeln(F, S);                          { Read the first line out of the file }
                 lastString := S;
                 Next;
             end;
        end;
        CloseFile(F);
        ShowMessage('sɧ');
    end;
end;
*)

procedure TForm2.FormActivate(Sender: TObject);
begin
    //showMessage('FormActivate');
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
    //showMessage('FormCreate');
    NowRightEnd := 0;
    ColTitleList := TList.Create;
    ColDetailList := TList.Create;
end;

procedure TForm2.FormDestroy(Sender: TObject);
var i : Integer;
begin
    for i := 1 to ColTitleList.Count -1 do
        TQRLabel(ColTitleList.Items[i]).free;
    ColTitleList.free;

    for i := 1 to ColDetailList.Count -1 do
        TQRDBText(ColDetailList.Items[i]).free;
    ColDetailList.free;
end;

procedure TForm2.qrbdetailBeforePrint(Sender: TQRCustomBand;
    var PrintBand: Boolean);
    var S :String;
    var i : Integer;
begin
    S := '';
    with myDataSet do  begin
        with myDBGrid do begin
            for i := 0 to FieldCount-1 do begin
                if Columns.Items[i].Width > 15 then
                    S := S + strPadr(FieldByName(Columns.Items[i].FieldName).AsString,2+(Columns.Items[i].Width + 8) div 9 );
                if S <> TempColumnStr then begin // Delete Same Columns
                    PrintBand := True
                end else begin
                    PrintBand := False;
                    TempColumnStr := S;
                end;
            end;
        end;
    end;

end;

end.
 